##################################################
# Fonction qui dtecte si un poly convexe
# est inclus ou contient ou est distinct ou
# chevauche un autre
##################################################

# #########################################################

if (!isGeneric("inConvex"))
	setGeneric("inConvex", function(x,  y,
 digits=2, 
		  maxvertices=50,
		  notconvex )
		standardGeneric("inConvex"))
# ____________________________________
# Cration de la dfinition par dfaut 'inConvex'
# ____________________________________
inConvex.default = function(x, y, digits=2, maxvertices=50,
		  notconvex)
  {
  if (!inherits(x,"Polygons")  && !inherits(x,"Polygon"))
    stop("This function is valid only on a 'Polygons' or 'Polygon' object.")
if (inherits(x,"Polygons"))
   inConvex.Polygons(x,y, digits, maxvertices, notconvex)
else
inConvex.Polygon(x, y, digits, maxvertices, notconvex)
	
  }
# -----------------------------------------------



# -----------------------------------------------------
#  multiplier par 10**digits
# -----------------------------------------------------
prepPoly = function(x, digits)
{
a = slot(x, "coords")
p1=matrix(NA, nrow=nrow(a), ncol=2)
for (i in 1:nrow(a))
 p1[i,]=a[i,]*(10**digits)
nia = as.integer(nrow(p1))
return(list(p1=p1, nia=nia))
}

# ------------------------------------------------
# Fonction qui traite un couple de polygones x et y
# --------------------------------------------------

inConvex.Polygon=
function(x,  y,
 digits=2, 
		  maxvertices=50,
		  notconvex )
{

# Regarder si les polys sont convexes
 notconvex = (!isConvex(x) || !isConvex(y))
if (notconvex)
   return(NA)

# mettre les coordonnees anticlock si elles ne le sont pas
# i.e si c'est  pas un trou
p1 = putAntiClock.Polygon(x)
p2 = putAntiClock.Polygon(y)

#  multiplier par 10**digits
pp1= prepPoly(p1, digits)
pp2= prepPoly(p2, digits)

# Appel du C:
inclus=0

ret = .C("inconvex", as.integer(maxvertices),
    as.double(pp1$p1), as.double(pp2$p1),
as.integer(pp1$nia), as.integer(pp2$nia),
inclus= as.integer(inclus),
 PACKAGE="landm")


codes = c("D","I","C","S")
return(codes[ret$inclus + 1])

} # fin inConvex.Polygon

setMethod("inConvex", signature(x = "Polygon"),inConvex.Polygon)


# ____________________________________
# Cration de la dfinition spcialise  Polygons
#  Le retour est une matrice 
#  retour[i,j] = un code selon que le poly j est inclus,
#  chevauche, contient, est distinct de i,
#  pour tous les couples des polys de x
# si i ou j n'est pas convex:  retour[i,j] =NA
# ____________________________________

inConvex.Polygons=
function(x, y, digits=2,
		  maxvertices=50, notconvex)
{
retour = matrix(NA, nrow= length(slot(x, "Polygons")),
       ncol= length(slot(x, "Polygons")))
# L'indicateur de convexite
estconv = isConvex(x)

for (i in 1:length(slot(x, "Polygons")))
{
unpoly = slot(x, "Polygons")[[i]]
for (j in 1:length(slot(x, "Polygons")))
{
deuxpoly = slot(x, "Polygons")[[j]]
retour[i,j]= inConvex.Polygon( unpoly, deuxpoly, digits,
	     maxvertices,
	     notconvex = (!estconv[i]|| !estconv[j]))
}
}
return(retour)
} # fin inConvex.Polygons


setMethod("inConvex", signature(x = "Polygons", y = "missing",
 notconvex="missing"), inConvex.Polygons)
