\name{isConvex.Polygons}
\alias{isConvex.Polygons}
\title{ Test the convexity of polygons. }
\description{
Test the convexity of a list of polygons. 
}
\usage{
isConvex.Polygons(x, verbose = FALSE, id)
}
\arguments{
  \item{x}{  An object of the \code{\link[sp]{Polygons-class}} }
  \item{verbose}{  Logical; when TRUE, details on the 
 process are given  }
\item{id}{ Ignored }
}
\details{
  ~~ If necessary, more details than the description above ~~
}
\value{
A logical vector of length equal to the number of
polygons in \code{x}.
The element i is equal to TRUE if the polygon 
i
is convex, FALSE otherwise.
}
\author{  A. Bouvier }
\seealso{  \code{\link{crConvex.Polygons}} \code{\link{isConvex.Polygon}}}
\examples{
p1=Polygon(cbind(c(540272, 540274, 540278, 540156, 540151, 
       540247, 540272),
  c(1794890, 1794850, 1794800, 1794820, 1794840, 1794870, 1794890)))
p2=Polygon(cbind(c( 540261, 540378, 540374, 540362, 540318, 540315, 
540301, 540304, 540311, 540361,
540357, 540336, 540323, 540274, 540272, 540273, 540261),
c(1795000, 1795000, 1794890, 1794880, 1794890, 
1794970, 1794970, 1794910, 1794880,
1794880, 1794790, 1794790, 1794860, 1794850, 1794890, 
1794920, 1795000)))
lp=Polygons(list(p1,p2),"")
plot(lp)
isConvex(lp)
}
\keyword{manip}
\keyword{methods}
